OpenCL C++ Bindings: cl::Image2DGL Class Reference

OpenCL C++ Bindings

Loading...
Searching...
No Matches
Public Member Functions | List of all members
cl::Image2DGL Class Reference

Class interface for GL 2D Image Memory objects. More...

`#include <opencl.hpp>`

Inheritance diagram for cl::Image2DGL:

## Public Member Functions
| Image2DGL (const Context &context, cl_mem_flags flags, cl_GLenum target, cl_GLint miplevel, cl_GLuint texobj, cl_int *err=nullptr)
| Constructs an Image2DGL in a specified context, from a given GL Texture.
| Image2DGL ()
| Default constructor - initializes to nullptr.
| Image2DGL (const cl_mem &image, bool retainObject=false)
| Constructor from cl_mem - takes ownership.
Image2DGL & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy. c See Memory for further details.
Public Member Functions inherited from cl::Image2D
| Image2D (const Context &context, cl_mem_flags flags, ImageFormat format, size_type width, size_type height, size_type row_pitch=0, void *host_ptr=nullptr, cl_int *err=nullptr)
| Constructs a 2D Image in a specified context.
| Image2D (const Context &context, ImageFormat format, const Buffer &sourceBuffer, size_type width, size_type height, size_type row_pitch=0, cl_int *err=nullptr)
| Constructs a 2D Image from a buffer.
| Image2D (const Context &context, cl_channel_order order, const Image &sourceImage, cl_int *err=nullptr)
| Constructs a 2D Image from an image.
| Image2D ()
| Default constructor - initializes to nullptr.
| Image2D (const cl_mem &image2D, bool retainObject=false)
| Constructor from cl_mem - takes ownership.
Image2D & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy.
Public Member Functions inherited from cl::Image
template<typename T >
cl_int | getImageInfo (cl_image_info name, T *param) const
| Wrapper for clGetImageInfo().
template<cl_image_info name>
detail::param_traits< detail::cl_image_info, name >::param_type | getImageInfo (cl_int *err=nullptr) const
| Wrapper for clGetImageInfo() that returns by value.
Public Member Functions inherited from cl::Memory
| Memory ()
| Default constructor - initializes to nullptr.
| Memory (const cl_mem &memory, bool retainObject)
| Constructor from cl_mem - takes ownership.
Memory & | operator= (const cl_mem &rhs)
| Assignment operator from cl_mem - takes ownership.
template<typename T >
cl_int | getInfo (cl_mem_info name, T *param) const
| Wrapper for clGetMemObjectInfo().
template<cl_mem_info name>
detail::param_traits< detail::cl_mem_info, name >::param_type | getInfo (cl_int *err=nullptr) const
| Wrapper for clGetMemObjectInfo() that returns by value.
cl_int | setDestructorCallback (void(CL_CALLBACK *pfn_notify)(cl_mem, void *), void *user_data=nullptr)
| Registers a callback function to be called when the memory object is no longer needed.
Public Member Functions inherited from cl::detail::Wrapper< cl_mem >
| Wrapper (const cl_type &obj, bool retainObject)
| Wrapper (const Wrapper< cl_type > &rhs)
| Wrapper (Wrapper< cl_type > &&rhs) CL_HPP_NOEXCEPT_
Wrapper< cl_type > & | operator= (const Wrapper< cl_type > &rhs)
Wrapper< cl_type > & | operator= (Wrapper< cl_type > &&rhs)
Wrapper< cl_type > & | operator= (const cl_type &rhs)
const cl_type & | operator() () const
cl_type & | operator() ()
cl_type | get () const

## Additional Inherited Members
Public Types inherited from cl::detail::Wrapper< cl_mem >
typedef cl_mem | cl_type
Protected Member Functions inherited from cl::Image
| Image ()
| Default constructor - initializes to nullptr.
| Image (const cl_mem &image, bool retainObject=false)
| Constructor from cl_mem - takes ownership.
Image & | operator= (const cl_mem &rhs)
| Assignment from cl_mem - performs shallow copy.
Protected Member Functions inherited from cl::detail::Wrapper< cl_mem >
cl_int | retain () const
cl_int | release () const
Protected Attributes inherited from cl::detail::Wrapper< cl_mem >
cl_type | object_

## Detailed Description

Class interface for GL 2D Image Memory objects.

This is provided to facilitate interoperability with OpenGL.

See Memory for details about copy semantics, etc.

See also
  Memory

Note
  Deprecated for OpenCL 1.2. Please use ImageGL instead.

Definition at line 4997 of file opencl.hpp.

## Constructor & Destructor Documentation

## ◆ Image2DGL() [1/3]

cl::Image2DGL::Image2DGL | ( | const Context & | context,
|  | cl_mem_flags | flags,
|  | cl_GLenum | target,
|  | cl_GLint | miplevel,
|  | cl_GLuint | texobj,
|  | cl_int * | err = `nullptr`
| ) |  |
| inline

Constructs an Image2DGL in a specified context, from a given GL Texture.

Wraps clCreateFromGLTexture2D().

Definition at line 5005 of file opencl.hpp.

## ◆ Image2DGL() [2/3]

cl::Image2DGL::Image2DGL | ( |  | ) |
| inline

Default constructor - initializes to nullptr.

Definition at line 5030 of file opencl.hpp.

## ◆ Image2DGL() [3/3]

cl::Image2DGL::Image2DGL | ( | const cl_mem & | image,
|  | bool | retainObject = `false`
| ) |  |
| inlineexplicit

Constructor from cl_mem - takes ownership.

Parameters

  retainObject | will cause the constructor to retain its cl object. Defaults to false to maintain compatibility with earlier versions. See Memory for further details.

Definition at line 5039 of file opencl.hpp.

## Member Function Documentation

## ◆ operator=()

Image2DGL & cl::Image2DGL::operator= | ( | const cl_mem & | rhs | ) |
| inline

Assignment from cl_mem - performs shallow copy. c See Memory for further details.

Definition at line 5046 of file opencl.hpp.

The documentation for this class was generated from the following file:

- opencl.hpp